#ifndef _TUPLEBUFFER_H_
#define _TUPLEBUFFER_H_

#include <ctime>
#include <stdio.h>
#include <iostream>
#include <sys/param.h>
#include <sys/times.h>
#include <sys/types.h>
#include <fstream>
#include <iostream>
#include "Constants.h"

using namespace std;


class TupleBuffer
{

 public:

  TupleBuffer(int numBytes_, int id_); //start counting time
  ~TupleBuffer();
  byte* addTuple(byte* tuple, int tupleSize);

  inline byte* allocateTuple(int tupleSize) {
    byte* toReturn = currPos;
    if (currPos+tupleSize > endPos) {
      printf("ERROR: No space left in buffer with id %d.\n", id);
      exit(1);
    }
    currPos+=tupleSize;
    return toReturn;
  }

 private:

  byte* buffer;
  int numBytes;
  byte* endPos;
  byte* currPos;
  int id;

};

#endif //_TUPLEBUFFER_H_
